#include "TeensyPwm.h"

#include <stdint.h>
#include <LiquidCrystal.h>

#include "hardware.h"
#include "rotary.h"
#include "pwm.h"







LiquidCrystal lcd(LCD_RS, LCD_E, LCD_D4, LCD_D5, LCD_D6, LCD_D7);
const uint32_t DISPLAY_UPDATE_TIME = 5e5; // microseconds



void setup() {
	Serial.begin(115200);
	lcd.begin(LCD_COLS, LCD_ROWS);
	lcd.print("Teensy SMPS");
	Serial.println("Teensy SMPS");

  pwmInit();
	rotaryInit();
}

void loop() {
	static uint32_t lastDisplayCycle = 0;
	uint32_t currentTime = micros();
	if ((lastDisplayCycle + DISPLAY_UPDATE_TIME <= currentTime) || (lastDisplayCycle > currentTime)) {
		lastDisplayCycle = currentTime;

		int rotaryCount = getAndResetRotaryCount();
    if (rotaryCount != 0) {
      setUDes(getUDes() + rotaryCount);
    }

		lcd.clear();
		lcd.setCursor(0, 0);
		lcd.print(getUdes());
		lcd.setCursor(8, 0);
		lcd.print(getUCur());
		lcd.setCursor(0, 1);
		lcd.print(geDutyCycle());
		lcd.print("%");
	}
}
